<?php

if( !defined('IN_ROSTER') )
{
    exit('Detected invalid access to this file!');
}

require_once (ROSTER_LIB . 'skill.php');
require_once (ROSTER_LIB . 'recipes.php');

$charid = $roster->data['member_id'];
$skills = skill_get_many($charid);
$skill_list = array();
$i=0;
$skill_name = '';
$returnstring = '';
$returnstring .= "<a name=\"top\">&nbsp;</a>\n";
$returnstring .= '<div align="center">';
$skill_name_divider = '';
foreach ($skills as $skillgroup) {
	foreach ($skillgroup as $skill) {
		$st = $skill->data['skill_type'];
		if ($skill->data['skill_type']==$roster->locale->wordings[$roster->data['clientLocale']]['professions'] || $skill->data['skill_type']==$roster->locale->wordings[$roster->data['clientLocale']]['secondary']) {
			if ($skill->data['skill_name']!=$roster->locale->wordings[$roster->data['clientLocale']]['riding'] && $skill->data['skill_name']!=$roster->locale->wordings[$roster->data['clientLocale']]['Fishing'] && $skill->data['skill_name']!=$roster->locale->wordings[$roster->data['clientLocale']]['Skinning'] && $skill->data['skill_name']!=$roster->locale->wordings[$roster->data['clientLocale']]['Mining'] && $skill->data['skill_name']!=$roster->locale->wordings[$roster->data['clientLocale']]['Herbalism']) {
				$skill_list[$i] = $skill->data['skill_name'];
				$skill_level[$i] = $skill->data['skill_level'];
				$i++;
				$skill_name_header = $skill->data['skill_name'];
				$returnstring .= $skill_name_divider .'<a href="' . makelink('#' . strtolower(str_replace(' ','',$skill_name_header))) . '">' . $skill_name_header . '</a>';
				$skill_name_divider = '&nbsp;-&nbsp;';
			}
		}
	}
}
$returnstring .= "</div>\n<br />\n";

$allrecipes=array();
$i=0;
foreach($skill_list as $skill)
{
	switch($skill)
	{
	case $roster->locale->wordings[$roster->data['clientLocale']]['Alchemy']:
			$allrecipes[$i] = urlgrabber('http://wow.allakhazam.com/db/skill.html?line=171&source=live&tier=apprentice&locale='.$roster->data['clientLocale'],30);
			$allrecipes[$i] .= urlgrabber('http://wow.allakhazam.com/db/skill.html?line=171&source=live&tier=journeyman&locale='.$roster->data['clientLocale'],30);
			$allrecipes[$i] .= urlgrabber('http://wow.allakhazam.com/db/skill.html?line=171&source=live&tier=expert&locale='.$roster->data['clientLocale'],30);
			$allrecipes[$i] .= urlgrabber('http://wow.allakhazam.com/db/skill.html?line=171&source=live&tier=artisan&locale='.$roster->data['clientLocale'],30);
			$allrecipes[$i] .= urlgrabber('http://wow.allakhazam.com/db/skill.html?line=171&source=live&tier=master&locale='.$roster->data['clientLocale'],30);
			$i++;
			break;
		case $roster->locale->wordings[$roster->data['clientLocale']]['Blacksmithing']:
			$allrecipes[$i] = urlgrabber('http://wow.allakhazam.com/db/skill.html?line=164&source=live&tier=apprentice&locale='.$roster->data['clientLocale'],30);
			$allrecipes[$i] .= urlgrabber('http://wow.allakhazam.com/db/skill.html?line=164&source=live&tier=journeyman&locale='.$roster->data['clientLocale'],30);
			$allrecipes[$i] .= urlgrabber('http://wow.allakhazam.com/db/skill.html?line=164&source=live&tier=expert&locale='.$roster->data['clientLocale'],30);
			$allrecipes[$i] .= urlgrabber('http://wow.allakhazam.com/db/skill.html?line=164&source=live&tier=artisan&locale='.$roster->data['clientLocale'],30);
			$allrecipes[$i] .= urlgrabber('http://wow.allakhazam.com/db/skill.html?line=164&source=live&tier=master&locale='.$roster->data['clientLocale'],30);
			$i++;
			break;
		case $roster->locale->wordings[$roster->data['clientLocale']]['Cooking']:
			$allrecipes[$i] = urlgrabber('http://wow.allakhazam.com/db/skill.html?line=185&source=live&tier=apprentice&locale='.$roster->data['clientLocale'],30);
			$allrecipes[$i] .= urlgrabber('http://wow.allakhazam.com/db/skill.html?line=185&source=live&tier=journeyman&locale='.$roster->data['clientLocale'],30);
			$allrecipes[$i] .= urlgrabber('http://wow.allakhazam.com/db/skill.html?line=185&source=live&tier=expert&locale='.$roster->data['clientLocale'],30);
			$allrecipes[$i] .= urlgrabber('http://wow.allakhazam.com/db/skill.html?line=185&source=live&tier=artisan&locale='.$roster->data['clientLocale'],30);
			$allrecipes[$i] .= urlgrabber('http://wow.allakhazam.com/db/skill.html?line=185&source=live&tier=master&locale='.$roster->data['clientLocale'],30);
			$i++;
			break;
		case $roster->locale->wordings[$roster->data['clientLocale']]['Enchanting']:
			$allrecipes[$i] = urlgrabber('http://wow.allakhazam.com/db/skill.html?line=333&source=live&tier=apprentice&locale='.$roster->data['clientLocale'],30);
			$allrecipes[$i] .= urlgrabber('http://wow.allakhazam.com/db/skill.html?line=333&source=live&tier=journeyman&locale='.$roster->data['clientLocale'],30);
			$allrecipes[$i] .= urlgrabber('http://wow.allakhazam.com/db/skill.html?line=333&source=live&tier=expert&locale='.$roster->data['clientLocale'],30);
			$allrecipes[$i] .= urlgrabber('http://wow.allakhazam.com/db/skill.html?line=333&source=live&tier=artisan&locale='.$roster->data['clientLocale'],30);
			$allrecipes[$i] .= urlgrabber('http://wow.allakhazam.com/db/skill.html?line=333&source=live&tier=master&locale='.$roster->data['clientLocale'],30);
			$i++;
			break;
		case $roster->locale->wordings[$roster->data['clientLocale']]['Engineering']:
			$allrecipes[$i] = urlgrabber('http://wow.allakhazam.com/db/skill.html?line=202&source=live&tier=apprentice&locale='.$roster->data['clientLocale'],30);
			$allrecipes[$i] .= urlgrabber('http://wow.allakhazam.com/db/skill.html?line=202&source=live&tier=journeyman&locale='.$roster->data['clientLocale'],30);
			$allrecipes[$i] .= urlgrabber('http://wow.allakhazam.com/db/skill.html?line=202&source=live&tier=expert&locale='.$roster->data['clientLocale'],30);
			$allrecipes[$i] .= urlgrabber('http://wow.allakhazam.com/db/skill.html?line=202&source=live&tier=artisan&locale='.$roster->data['clientLocale'],30);
			$allrecipes[$i] .= urlgrabber('http://wow.allakhazam.com/db/skill.html?line=202&source=live&tier=master&locale='.$roster->data['clientLocale'],30);
			$i++;
			break;
		case $roster->locale->wordings[$roster->data['clientLocale']]['First Aid']:
			$allrecipes[$i] = urlgrabber('http://wow.allakhazam.com/db/skill.html?line=129&source=live&tier=apprentice&locale='.$roster->data['clientLocale'],30);
			$allrecipes[$i] .= urlgrabber('http://wow.allakhazam.com/db/skill.html?line=129&source=live&tier=journeyman&locale='.$roster->data['clientLocale'],30);
			$allrecipes[$i] .= urlgrabber('http://wow.allakhazam.com/db/skill.html?line=129&source=live&tier=expert&locale='.$roster->data['clientLocale'],30);
			$allrecipes[$i] .= urlgrabber('http://wow.allakhazam.com/db/skill.html?line=129&source=live&tier=artisan&locale='.$roster->data['clientLocale'],30);
			$allrecipes[$i] .= urlgrabber('http://wow.allakhazam.com/db/skill.html?line=129&source=live&tier=master&locale='.$roster->data['clientLocale'],30);
			$i++;
			break;
		case $roster->locale->wordings[$roster->data['clientLocale']]['Leatherworking']:
			$allrecipes[$i] = urlgrabber('http://wow.allakhazam.com/db/skill.html?line=165&source=live&tier=apprentice&locale='.$roster->data['clientLocale'],30);
			$allrecipes[$i] .= urlgrabber('http://wow.allakhazam.com/db/skill.html?line=165&source=live&tier=journeyman&locale='.$roster->data['clientLocale'],30);
			$allrecipes[$i] .= urlgrabber('http://wow.allakhazam.com/db/skill.html?line=165&source=live&tier=expert&locale='.$roster->data['clientLocale'],30);
			$allrecipes[$i] .= urlgrabber('http://wow.allakhazam.com/db/skill.html?line=165&source=live&tier=artisan&locale='.$roster->data['clientLocale'],30);
			$allrecipes[$i] .= urlgrabber('http://wow.allakhazam.com/db/skill.html?line=165&source=live&tier=master&locale='.$roster->data['clientLocale'],30);
			$i++;
			break;
		case $roster->locale->wordings[$roster->data['clientLocale']]['Tailoring']:
			$allrecipes[$i] = urlgrabber('http://wow.allakhazam.com/db/skill.html?line=197&source=live&tier=apprentice&locale='.$roster->data['clientLocale'],30);
			$allrecipes[$i] .= urlgrabber('http://wow.allakhazam.com/db/skill.html?line=197&source=live&tier=journeyman&locale='.$roster->data['clientLocale'],30);
			$allrecipes[$i] .= urlgrabber('http://wow.allakhazam.com/db/skill.html?line=197&source=live&tier=expert&locale='.$roster->data['clientLocale'],30);
			$allrecipes[$i] .= urlgrabber('http://wow.allakhazam.com/db/skill.html?line=197&source=live&tier=artisan&locale='.$roster->data['clientLocale'],30);
			$allrecipes[$i] .= urlgrabber('http://wow.allakhazam.com/db/skill.html?line=197&source=live&tier=master&locale='.$roster->data['clientLocale'],30);
			$i++;
			break;
		case $roster->locale->wordings[$roster->data['clientLocale']]['Jewelcrafting']:
			$allrecipes[$i] = urlgrabber('http://wow.allakhazam.com/db/skill.html?line=755&source=live&tier=apprentice&locale='.$roster->data['clientLocale'],30);
			$allrecipes[$i] .= urlgrabber('http://wow.allakhazam.com/db/skill.html?line=755&source=live&tier=journeyman&locale='.$roster->data['clientLocale'],30);
			$allrecipes[$i] .= urlgrabber('http://wow.allakhazam.com/db/skill.html?line=755&source=live&tier=expert&locale='.$roster->data['clientLocale'],30);
			$allrecipes[$i] .= urlgrabber('http://wow.allakhazam.com/db/skill.html?line=755&source=live&tier=artisan&locale='.$roster->data['clientLocale'],30);
			$allrecipes[$i] .= urlgrabber('http://wow.allakhazam.com/db/skill.html?line=755&source=live&tier=master&locale='.$roster->data['clientLocale'],30);
			$i++;
			break;
		default:
			$allrecipes[$i] ='';
			$i++;
			break;
	}
}
foreach($allrecipes as $index => $allrecipesperskill)
{
	preg_match_all('/(?<=\<tr class=\"[dl]r\"\>)((.(?!\<\/tr))*)/si',$allrecipesperskill,$matches);
	foreach ($matches[0] as $nr => $recipe)
	{
		preg_match_all('/(\<td[\w \\\'\"=]*\>)(.*)(?=\<\/td)/mi',$recipe,$lines)."\n";
//		aprint($lines);
		$parsedrecipes[$index][$nr]['icon'] = strtolower($lines[2][0]);
//		preg_match('/(\<a[^\>]* href=\"([^\"]*)\"\>)([^<]*)/i',$parsedrecipes[$index][$nr]['icon'],$match);
//		$fulliconlink = "<a href=\"http://wow.allakhazam.com".$match[2]."&locale=".$roster->data['clientLocale'];
		$parsedrecipes[$index][$nr]['icon'] = str_replace("src=\"/images/icons", "src=\"".ROSTER_URL.$roster->config['interface_url']."Interface/Icons", $parsedrecipes[$index][$nr]['icon']);
		$parsedrecipes[$index][$nr]['icon'] = str_replace(".png", ".".$roster->config['img_suffix']."\" alt=\"" , $parsedrecipes[$index][$nr]['icon']);
		$parsedrecipes[$index][$nr]['icon'] = str_replace("href=\"", "href=\"http://wow.allakhazam.com" , $parsedrecipes[$index][$nr]['icon']);
		$parsedrecipes[$index][$nr]['icon'] = str_replace("\"><img", "&locale=".$roster->data['clientLocale']."\"><img" , $parsedrecipes[$index][$nr]['icon']);
		preg_match_all('/(\<a[^\>]* href=\"([^\"]*)\"\>)([^<]*)/i',$lines[2][1],$name);
//		aprint($name);
		$parsedrecipes[$index][$nr]['name'] = $name[3][0];
		//preg_match('/href=\"([^\"]*)\"/i',$lines[2][5],$link);
		//$recipes[$index][$nr]['components'] = $lines[2][4];
		if(array_key_exists('0',$name[2])) {
			$parsedrecipes[$index][$nr]['i_link'] = $name[2][0];
		}
		//$recipes[$index][$nr]['category'] = $lines[2][2];
		$parsedrecipes[$index][$nr]['skill'] = $lines[2][3];
//		preg_match('/(\<a[^\>]* href=\"([^\"]*)\"\>)([^<]*)(.*(\<a[^\>]* href=\"([^\"]*)\"\>\<span[^\>]*\>)([^<]*))?/i',$lines[2][1],$name);
		$parsedrecipes[$index][$nr]['r_link'] = $name[2][0];
		if (isset($name[3][1]))
		{
			$parsedrecipes[$index][$nr]['pat_link'] = $name[2][1];
			$parsedrecipes[$index][$nr]['pat_name'] = $name[3][1];
		}
	}
}

//aprint($parsedrecipes);

$known = recipe_get_many( $charid,'', 'level' );
// aprint($known);
foreach($known as $kindex => $krecipe) {
	$knownrecipenames[]=$krecipe->data['recipe_name'];
}

foreach($skill_list as $sindex => $skill) {
	foreach($parsedrecipes[$sindex] as $nr => $recipe) {
//		aprint($recipe);
		$allrecipenames[$sindex][]=$recipe['name'];
	}
	$diffrecipenames[$sindex] = array_diff($allrecipenames[$sindex],$knownrecipenames);
}

//aprint($allrecipenames);
//aprint($knownrecipenames);

//aprint($skill_level);
//aprint($diffrecipenames);


$roster->tpl->set_filenames(array(
	'mr' => $addon['basename'] . '/mr.html',
	'mr_skill' => $addon['basename'] . '/mr_skill.html',
	)
);

$roster->tpl->assign_block_vars('mr', array(
	'SUPERHEADER' => $returnstring,
	)
);
$roster->tpl->display('mr');

foreach($skill_list as $sindex => $skill_name) {
	list($charskill_level, $maxskill_level) = explode(":", $skill_level[$sindex], 2);
	// make skill header
	// Set an link to the top behind the profession image
	$skill_image = 'Interface/Icons/' . $roster->locale->wordings[$roster->data['clientLocale']]['ts_iconArray'][$skill_name];
	$skill_image = "<img style=\"float:left;\" width=\"17\" height=\"17\" src=\"" . $roster->config['interface_url'] . $skill_image . '.' . $roster->config['img_suffix'] . "\" alt=\"\" />\n";

	$header = '<div style="cursor:pointer;width:600px;" onclick="showHide(\'table_' . $sindex . '\',\'img_' . $sindex . '\',\'' . $roster->config['img_url'] . 'minus.gif\',\'' . $roster->config['img_url'] . 'plus.gif\');">' . $skill_image . '<div style="display:inline;float:right;"><img id="img_' . $sindex . '" src="' . $roster->config['img_url'] . 'plus.gif" alt="" /></div><a name="' . strtolower(str_replace(' ','',$skill_name)) . '"></a>' . $skill_name . '&nbsp;' . $charskill_level . ':' . $maxskill_level .'</div>';

	$roster->tpl->assign_block_vars('mr_skill', array(
		'HEADER'	=>	border('sgray','start',$header) . "<table width=\"100%\" style=\"display:none;\";\" class=\"bodyline\" cellspacing=\"0\" id=\"table_$sindex\">",
		'ITEM'	=> $roster->locale->act['item'],
		'NAME'	=> $roster->locale->act['name'],
		'SLVL'	=> $roster->locale->act['skill_level'],
		'SUBHEADER'	=> '<th class="membersHeader">' . $roster->locale->act['item'] . '</th>  <th class="membersHeader">' . $roster->locale->act['name'] . '</th> <th class="membersHeader">' . $roster->locale->act['skill_level'] . '</th>',
		'FOOTER'	=> "</table>" . border('sgray','end'),
		)
	);

	$stripe = 0;
	foreach($diffrecipenames[$sindex] as $dindex => $diffrecipename) {
		$returnstring = '';
		// make recipe row
		// skill level color (thanks to Ulminia)
		$skillmatches = array('<span class="orangename">','</span>&nbsp;<span class="yellowname">');
		$skillcleanup = str_replace( $skillmatches, ":", $parsedrecipes[$sindex][$dindex]['skill'] );
		list($skill_null,$skill_learn,$skill_rest) = explode(":", $skillcleanup, 3);
		$charskill_level2 = explode(":", $charskill_level);
		if ($charskill_level2[0]>=$skill_learn )
		{
			$skill_color = "00FF00";
		} else {
			$skill_color = "FF0000";
		}

		$stripe = (($stripe%2)+1);
		
		$sqlquery = 'SELECT recipe_name, item_color, recipe_tooltip FROM '.$roster->db->table('recipes').' WHERE recipe_name = "'.$parsedrecipes[$sindex][$dindex]['name'].'"';
		$sqlresult = $roster->db->query($sqlquery);
		$sqlrow = $roster->db->fetch($sqlresult);
		$inserttt = '';
		if ($sqlrow) {
			$inserttt = makeOverlib($sqlrow['recipe_tooltip']."\n",$sqlrow['recipe_name'],'',0,'','');
		}

		$returnstring .= '  <td class="membersRow' . $stripe . ' equip" '.$inserttt.' >' . $parsedrecipes[$sindex][$dindex]['icon'] . '</td>';
		if(array_key_exists('i_link', $parsedrecipes[$sindex][$dindex]))
		{
			$link = 'http://wow.allakhazam.com'.$parsedrecipes[$sindex][$dindex]['i_link'];
			$returnstring .= '</td><td class="membersRow' . $stripe . '"><span><a href="' . $link . '">&nbsp;' . $parsedrecipes[$sindex][$dindex]['name'] . '</a></span>';
		} else {
			$returnstring .= '</td><td class="membersRow' . $stripe . '"><span style="color:#CBA300">&nbsp;' . $parsedrecipes[$sindex][$dindex]['name'] . '</span>';
		}
		if(array_key_exists('pat_link', $parsedrecipes[$sindex][$dindex]))
		{
			$plink = "http://wow.allakhazam.com".$parsedrecipes[$sindex][$dindex]['pat_link'];
			$pname = $parsedrecipes[$sindex][$dindex]['pat_name'];
			$returnstring .= "<br /><a href=\"$plink\">&nbsp;$pname</a>";
		}
		$returnstring .= '</td>';
		$returnstring .= '<td class="membersRow' . $stripe . '"><span style="color:#'.$skill_color.'" >&nbsp;' . $parsedrecipes[$sindex][$dindex]['skill'] . '</span></td>  ';

		$roster->tpl->assign_block_vars('mr_skill.mr_recipe', array(
			'ROW' => $returnstring,
			)
		);
	}
}
$roster->tpl->display('mr_skill');
