<?php
/**
 * WoWRoster.net WoWRoster
 *
 * LICENSE: Licensed under the Creative Commons
 *          "Attribution-NonCommercial-ShareAlike 2.5" license
 *
 * @copyright  2002-2007 WoWRoster.net
 * @license    http://creativecommons.org/licenses/by-nc-sa/2.5   Creative Commons "Attribution-NonCommercial-ShareAlike 2.5"
 * @version    SVN: $Id: install.def.php 897 2007-05-06 00:35:11Z Zanix $
 * @link       http://www.wowroster.net
 * @package    Forum
 * @subpackage Installer
*/
 
if ( !defined('IN_ROSTER') )
{
    exit('Detected invalid access to this file!');
}
 
/**
 * Installer Forum
 *
 * @package    Missing Recipe
 * @subpackage Installer
 */
class MissingRecipesInstall
{
	var $active = true;
	var $icon = 'inv_scroll_06';
 
	var $version = '2.0.0.6-alpha';
	var $wrnet_id = '0';
 
	var $fullname = 'missing_recipe';
	var $description = 'missing_recipe_desc';
	var $credits = array(
	array(	"name"=>	"Teta",
			"info"=>	"Roster 2 Porter"),
	array(	"name"=>	"Holgiranemsi",
			"info"=>	"German localization"),
	array(	"name"=>	"Theophilius",
			"info"=>	"R2 Port FRfr version"),
	array(	"name"=>	"Subxero",
			"info"=>	"R2 Port Localized version"),
	array(	"name"=>	"Zeryl",
			"info"=>	"Original addon developer"),
	array(	"name"=>	"Ulminia",
			"info"=>	"Coloring the skill levels"),
	array(	"name"=>	"Pleegwat",
			"info"=>	"Regex Master"),
	);
 
 
	/**
	 * Install Function
	 *
	 * @return bool
	 */
	function install()
	{
		global $installer;
 
		// Master and menu entries
		$installer->add_menu_button('missing_recipe_button','char');
 
		return true;
	}
 
	/**
	 * Upgrade Function
	 *
	 * @param string $oldversion
	 * @return bool
	 */
	function upgrade($oldversion)
	{
		// Nothing to upgrade from yet
		return true;
	}
 
	/**
	 * Un-Install Function
	 *
	 * @return bool
	 */
	function uninstall()
	{
		global $installer;
 
		$installer->remove_all_menu_button();
		return true;
	}
}